#!/usr/bin/python
# -*- coding: utf-8 -*-

from math import sqrt
import numpy as np

input_file_name = "force.dat"
natoms = 16

input_file = open(str(input_file_name), "r")

forces = np.empty((natoms, 3), 'd')
errors = np.empty((natoms, 3), 'd')

force_type = "Total Force+ZV(dloc)"

normal = [[1,-1,1],
[1,-1,1],
[1,-1,-1],
[1,-1,-1],
[1,1,1],
[1,1,1],
[1,1,-1],
[1,1,-1],
[-1,1,-1],
[-1,1,-1],
[-1,1,1],
[-1,1,1],
[-1,-1,1],
[-1,-1,1],
[-1,-1,-1],
[-1,-1,-1]]

input_file.seek(0)
for line in input_file:
    if line.strip().startswith("Forces on atom"):
        split_line = line.split()
        atom = int(split_line[3])-1
        axis = int(split_line[6])-1
    if line.strip().startswith(force_type):
        split_line = line.split()
        mean = float(split_line[3])
        err = float(split_line[4])
        forces[atom, axis] = mean
        errors[atom, axis] = err

normal_forces = forces * np.array(normal)
sum_forces = np.sum(normal_forces, axis=1)/3.0
sum_errors = np.sqrt(np.sum(errors**2, axis=1))/3.0

H_forces = (sum_forces[0] + sum_forces[2] + sum_forces[4] + sum_forces[6] + sum_forces[8] + sum_forces[10] + sum_forces[12] + sum_forces[14])/8.0
C_forces = (sum_forces[1] + sum_forces[3] + sum_forces[5] + sum_forces[7] + sum_forces[9] + sum_forces[11] + sum_forces[13] + sum_forces[15])/8.0

H_errors = sqrt((sum_forces[0]**2 + sum_forces[2]**2 + sum_forces[4]**2 + sum_forces[6]**2 + sum_forces[8]**2 + sum_forces[10]**2 + sum_forces[12]**2 + sum_forces[14]**2))/8.0
C_errors = sqrt((sum_forces[1]**2 + sum_forces[3]**2 + sum_forces[5]**2 + sum_forces[7]**2 + sum_forces[9]**2 + sum_forces[11]**2 + sum_forces[13]**2 + sum_forces[15]**2))/8.0

#H_forces = normal_forces[0] + normal_forces[2] + normal_forces[4] + normal_forces[6] + normal_forces[8] + normal_forces[10] + normal_forces[12] + normal_forces[14]
#C_forces = normal_forces[1] + normal_forces[3] + normal_forces[5] + normal_forces[7] + normal_forces[9] + normal_forces[11] + normal_forces[13] + normal_forces[15]

print "H_forces", H_forces, H_errors
print "C_forces", C_forces, C_errors
print "CM forces", H_forces + C_forces, sqrt(H_errors**2 + C_errors**2)
